import requests

from pathlib import Path
import tqdm

import argparse
import os


IMG_REC_SERVICE = 'http://localhost:8290/bcir/'

if __name__ == '__main__':
    parser = argparse.ArgumentParser(description='Img Recognition Bulk Analysis')
    parser.add_argument('src', type=str, help='img src folder path')
    parser.add_argument('dest', type=str, help='dest file path')

    args = parser.parse_args()
    src = args.src
    dest = args.dest

    paths = Path(src).rglob('*.*')
    paths_list = list(paths)

    print('Analyzing images...')
    with open(dest, 'w', encoding='UTF8') as f:
        for path in tqdm.tqdm(paths_list):
            try:
                img_file = {'image': (
                'query', open(os.path.join(path.parent, path.name), 'rb'))}
                r = requests.post(IMG_REC_SERVICE + 'searchByImg', files=img_file)
                res = r.json()
                tmp = ';'.join([str(i) for x in res for i in x])
                row = path.name + ";" + tmp
                f.write(row + '\n')
            except Exception as e:
                print("cannot process '%s'" % path)
                print(e)
                pass
