import requests

from pathlib import Path
import tqdm

import argparse
import os


IMG_REC_SERVICE = 'http://localhost:8290/bcir/'

groundtruth_file = '/media/ssd2/data/swoads/workdir/data/groundtruth_no_ext.txt'

precision_at = [0] * 10



if __name__ == '__main__':
    parser = argparse.ArgumentParser(description='Img Recognition Bulk Analysis')
    parser.add_argument('src', type=str, help='img src folder path')
    #parser.add_argument('dest', type=str, help='dest file path')

    args = parser.parse_args()
    src = args.src
    #dest = args.dest

    groundtruth = {}
    with open(groundtruth_file, 'r') as f:
        for line in f:
            line = line.rstrip()  # removes trailing whitespace and '\n' chars

            if "," not in line: continue  # skips blanks and comments w/o =
            if line.startswith("#"): continue  # skips comments which contain =

            k, v = line.split(",", 1)
            groundtruth[k] = v

    paths = Path(src).rglob('*.*')
    paths_list = list(paths)


    print('Analyzing images...')
    for path in tqdm.tqdm(paths_list):
        key = path.name
        expected_id = groundtruth[key]
       # print(exprected_id)
        try:
            img_file = {'image': (
            'query', open(os.path.join(path.parent, path.name), 'rb'))}
            params = {'searchDeepLevel': 3}

            r = requests.post(IMG_REC_SERVICE + 'searchByImg', data=params, files=img_file)
            res = r.json()

            for i in range (0, len(res)):
                if res[i][0] in expected_id:
                    #print("found at " + str(i))
                    precision_at[i] = precision_at[i] + 1
        except Exception as e:
            print("cannot process '%s'" % path)
            print(e)
            pass
    print(precision_at)
