import json
import os

def load_setting(conf_file):
    global port, feature_extractor, k, img_folder, logs, working_folder, data_folder, DATASET_LF_FOLDER, DATASET_GF_FOLDER, DATASET, DATASET_IDS, DB_LF, SEARCH_THRESHOLD, SEARCH_DEEP_LEVEL

    with open(conf_file) as settings_file:

        settings = json.load(settings_file)

        port = settings['port']
        feature_extractor = settings['fe_service']

        k = settings['k']
        working_folder =  settings['working_folder']

        data_folder = os.path.join(working_folder, settings['data_folder'])

        if not os.path.isdir(data_folder):
            os.mkdir(data_folder)

        DATASET_LF_FOLDER = os.path.join(data_folder, 'lf')
        DATASET_GF_FOLDER = os.path.join(data_folder, 'gf')
        DATASET = os.path.join(DATASET_GF_FOLDER, 'dataset.npy')
        DATASET_IDS = os.path.join(DATASET_GF_FOLDER, 'dataset.ids')
        DB_LF = os.path.join(data_folder, 'sqlite_lf/lf.db')
        SEARCH_THRESHOLD = settings['search_th']
        SEARCH_DEEP_LEVEL = settings['search_dl']


        img_folder = settings['img_folder']
        logs = os.path.join(working_folder, settings['log_folder'])
        if not os.path.isdir(logs):
            os.mkdir(logs)



