from pathlib import Path
import tqdm

import LFUtilities
import BEBLIDExtractorD as lf
import argparse
import os


if __name__ == '__main__':
    parser = argparse.ArgumentParser(description='LF bulk extraction')
    parser.add_argument('src', type=str, help='img src folder path')
    parser.add_argument('dest', type=str, help='lf dest folder')

    args = parser.parse_args()
    src = args.src
    dest = args.dest

    paths = Path(src).rglob('*.*')
    paths_list = list(paths)

    print('Extracting lf...')
    for path in tqdm.tqdm(paths_list):
        try:
            kp, des = lf.extract(os.path.join(path.parent, path.name))
            filename = os.path.splitext(path.name)[0]
            #LFUtilities.save_img_lf(dest, filename, kp, des)
            #LFUtilities.savez_img_lf(dest, filename, kp, des)
            LFUtilities.pickle_img_lf(dest, filename, kp, des)
        except Exception as e:
            print("cannot process '%s'" % path)
            print(e)
            pass

    print('lf extracted.')
