import requests
import base64

BASE_URL = 'http://bilioso.isti.cnr.it:8290/bcir/'

# ------Get indexed IDS------
payload = {'id': '54b3298aed5082b093939ea1-IMG881380', 'k': 10, 'threshold': 0.25, 'searchDeepLevel': 1}
r = requests.get(BASE_URL + 'getIds')
print(r.json())

# ------Check if an ID exists------
payload = {'id': '54b3298aed5082b093939ea1-IMG881380'}
r = requests.get(BASE_URL + 'exists', params=payload)
print(r.json())

# ------Searching by ID------
print('Searching by ID')
payload = {'id': '54b3298aed5082b093939ea1-IMG881380', 'k': 10, 'threshold': 0.25, 'searchDeepLevel': 1}
r = requests.get(BASE_URL + 'searchById', params=payload)
print(r.json())

# ------Searching by IMG------
print('Searching by IMG')
files = {'image': ('query', open('/media/data2/data/swoads/workdir/img/ImmaginiComparazioni/ACC130111[1].jpg', 'rb'))}
data = {'k': 10, 'threshold': 0.25, 'searchDeepLevel': 1}
r = requests.post(BASE_URL + 'searchByImg', data=data, files=files)
print(r.json())

# ------Searching by IMG Basa64------
print('Searching by IMG Base64')
with open('/media/data2/data/swoads/workdir/img/ImmaginiComparazioni/ACC130111[1].jpg', "rb") as img_file:
    b64_encoding = base64.b64encode(img_file.read())
data = {'image':b64_encoding, 'k': 10, 'threshold': 0.25, 'searchDeepLevel': 1}
r = requests.post(BASE_URL + 'searchByImgB64', data=data, files=files)
print(r.json())

# ------Searching by URL------
print('Searching by URL')
payload = {'url': 'http://bilioso.isti.cnr.it:8290/bcir/54b3298aed5082b093939ea1-IMG881380.jpg', 'k': 10,
           'threshold': 0.25, 'searchDeepLevel': 1}
r = requests.get(BASE_URL + 'searchByURL', params=payload)
print(r.json())

# ------Adding newIMG------
print('Adding newIMG')
files = {'image': (
'newIMG', open('/media/ssd2/data/swoads/workdir/img/ImmaginiComparazioni/ACC97468-149[3].jpg', 'rb'))}
r = requests.post(BASE_URL + 'addImg', files=files)
s = r.json()
print(r.json())

# ------Searching by newIMG------
print('Searching by newIMG')
files = {'image': (
'query', open('/media/ssd2/data/swoads/workdir/img/ImmaginiComparazioni/ACC97468-149[3].jpg', 'rb'))}
data = {'k': 10, 'threshold': 0.25, 'searchDeepLevel': 1}

r = requests.post(BASE_URL + 'searchByImg', data=data, files=files)
print(r.json())

# ------Removing newIMG------
print('Removing newIMG')
payload = {'id': 'newIMG'}
r = requests.get(BASE_URL + 'rmImg', params=payload)
print(r.json())

# ------Searching by newIMG now removed from the index------
print('Searching by newIMG now removed from the index')
files = {'image': (
'query', open('/media/ssd2/data/swoads/workdir/img/ImmaginiComparazioni/ACC97468-149[3].jpg', 'rb'))}
data = {'k': 10, 'threshold': 0.25, 'searchDeepLevel': 1}
r = requests.post(BASE_URL + 'searchByImg', data=data, files=files)
print(r.json())
